Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Parameters.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Parameters.cpp	(revision 88)
@@ -0,0 +1,90 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/include/Parameters.h"
+#include "Common/include/Max.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace special_register_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Special_Register_unit::Parameters"
+  Parameters::Parameters (uint32_t     nb_front_end          ,
+			  uint32_t   * nb_context            ,
+			  uint32_t     nb_inst_reexecute     ,
+			  bool     *** implement_group       ,
+                          bool         is_toplevel
+			  )
+  {
+    log_begin(Special_Register_unit,FUNCTION);
+    
+    _nb_front_end           = nb_front_end     ;
+    _nb_context             = nb_context       ;
+    _nb_inst_reexecute      = nb_inst_reexecute;
+    _implement_group        = implement_group  ;
+
+    _max_nb_context         = max<uint32_t>(_nb_context,_nb_front_end);
+//  _size_front_end_id      = log2(_nb_front_end);
+//  _size_context_id        = log2(_max_nb_context  );
+//  
+//  _have_port_front_end_id = _size_front_end_id > 0;
+//  _have_port_context_id   = _size_context_id   > 0;
+	
+    test();
+
+    if (is_toplevel)
+      {
+        _size_front_end_id      = log2(_nb_front_end);
+        _size_context_id        = log2(_max_nb_context  );
+        
+        _have_port_front_end_id = _size_front_end_id > 0;
+        _have_port_context_id   = _size_context_id   > 0;
+
+        copy();
+      }
+
+
+    log_end(Special_Register_unit,FUNCTION);
+  };
+  
+// #undef  FUNCTION
+// #define FUNCTION "Special_Register_unit::Parameters (copy)"
+//   Parameters::Parameters (Parameters & param)
+//   {
+//     log_begin(Special_Register_unit,FUNCTION);
+//     test();
+//     log_end(Special_Register_unit,FUNCTION);
+//   };
+
+#undef  FUNCTION
+#define FUNCTION "Special_Register_unit::~Parameters"
+  Parameters::~Parameters (void) 
+  {
+    log_begin(Special_Register_unit,FUNCTION);
+    log_end(Special_Register_unit,FUNCTION);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Special_Register_unit::copy"
+  void Parameters::copy (void) 
+  {
+    log_begin(Special_Register_unit,FUNCTION);
+    log_end(Special_Register_unit,FUNCTION);
+  };
+
+}; // end namespace special_register_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Parameters_msg_error.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Parameters_msg_error.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Parameters_msg_error.cpp	(revision 88)
@@ -0,0 +1,139 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/include/Parameters.h"
+#include <sstream>
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace special_register_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Special_Register_unit::msg_error"
+  Parameters_test Parameters::msg_error(void)
+  {
+    log_begin(Special_Register_unit,FUNCTION);
+
+    Parameters_test test ("Special_Register_unit");
+
+    for (uint32_t i=0; i<_nb_front_end; i++)
+      for (uint32_t j=0; j<_nb_context[i]; j++)
+	{
+	  if (_implement_group [i][j][GROUP_SYSTEM_AND_CONTROL ] == false)
+	    test.error(toString(_("Thread [%d][%d] : Group \"SYSTEM_AND_CONTROL\" must be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_DMMU               ] == true )
+	    test.error(toString(_("Thread [%d][%d] : Group \"DMMU\" can't be implemented : not yet supported.\n"),i,j));
+
+	  if (_implement_group [i][j][GROUP_IMMU               ] == true )
+	    test.error(toString(_("Thread [%d][%d] : Group \"IMMU\" can't be implemented : not yet supported.\n"),i,j));
+
+// 	  if (_implement_group [i][j][GROUP_DCACHE             ] == false)
+// 	    test.error(toString(_("Thread [%d][%d] : Group \"DCACHE\" must be implemented.\n"),i,j));
+
+	  if (_implement_group [i][j][GROUP_ICACHE             ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"ICACHE\" can't be implemented : not yet supported.\n"),i,j));
+
+// 	  if (_implement_group [i][j][GROUP_MAC                ] == true)
+// 	    test.error(toString(_("Thread [%d][%d] : Group \"MAC\" can't be implemented here. See functionnal_unit.\n"),i,j));
+
+	  if (_implement_group [i][j][GROUP_DEBUG              ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"DEBUG\" can't be implemented : not yet supported.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_PERFORMANCE_COUNTER] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"PERFORMANCE_COUNTER\" can't be implemented : not yet supported.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_POWER_MANAGEMENT   ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"POWER_MANAGEMENT\" can't be implemented : not yet supported.\n"),i,j));
+
+	  if (_implement_group [i][j][GROUP_PIC                ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"PIC\" can't be implemented : not yet supported.\n"),i,j));
+
+	  if (_implement_group [i][j][GROUP_TICK_TIMER         ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"TICK_TIMER\" can't be implemented : not yet supported.\n"),i,j));
+
+	  if (_implement_group [i][j][GROUP_FLOATING_POINT     ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"FLOATIN_POINT\" can't be implemented : not yet supported.\n"),i,j));
+
+	  if (_implement_group [i][j][GROUP_RESERVED_1         ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_1\" can't be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_RESERVED_2         ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_2\" can't be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_RESERVED_3         ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_3\" can't be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_RESERVED_4         ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_4\" can't be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_RESERVED_5         ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_5\" can't be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_RESERVED_6         ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_6\" can't be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_RESERVED_7         ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_7\" can't be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_RESERVED_8         ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_8\" can't be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_RESERVED_9         ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_9\" can't be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_RESERVED_10        ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_10\" can't be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_RESERVED_11        ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_11\" can't be implemented.\n"),i,j));
+	  
+	  if (_implement_group [i][j][GROUP_RESERVED_12        ] == true)
+	    test.error(toString(_("Thread [%d][%d] : Group \"RESERVED_12\" can't be implemented.\n"),i,j));
+	  
+// 	  if (_implement_group [i][j][GROUP_CUSTOM_1           ] == true)
+// 	    test.error(toString(_("Thread [%d][%d] : Group \"CUSTOM_1\" can't be implemented here. See functionnal_unit.\n"),i,j));
+	  
+// 	  if (_implement_group [i][j][GROUP_CUSTOM_2           ] == true)
+// 	    test.error(toString(_("Thread [%d][%d] : Group \"CUSTOM_2\" can't be implemented here. See functionnal_unit.\n"),i,j));
+	  
+// 	  if (_implement_group [i][j][GROUP_CUSTOM_3           ] == true)
+// 	    test.error(toString(_("Thread [%d][%d] : Group \"CUSTOM_3\" can't be implemented here. See functionnal_unit.\n"),i,j));
+	  
+// 	  if (_implement_group [i][j][GROUP_CUSTOM_4           ] == true)
+// 	    test.error(toString(_("Thread [%d][%d] : Group \"CUSTOM_4\" can't be implemented here. See functionnal_unit.\n"),i,j));
+	  
+// 	  if (_implement_group [i][j][GROUP_CUSTOM_5           ] == true)
+// 	    test.error(toString(_("Thread [%d][%d] : Group \"CUSTOM_5\" can't be implemented here. See functionnal_unit.\n"),i,j));
+	  
+// 	  if (_implement_group [i][j][GROUP_CUSTOM_6           ] == true)
+// 	    test.error(toString(_("Thread [%d][%d] : Group \"CUSTOM_6\" can't be implemented here. See functionnal_unit.\n"),i,j));
+	  
+// 	  if (_implement_group [i][j][GROUP_CUSTOM_7           ] == true)
+// 	    test.error(toString(_("Thread [%d][%d] : Group \"CUSTOM_7\" can't be implemented here. See functionnal_unit.\n"),i,j));
+	  
+// 	  if (_implement_group [i][j][GROUP_CUSTOM_8           ] == true)
+// 	    test.error(toString(_("Thread [%d][%d] : Group \"CUSTOM_8\" can't be implemented here. See functionnal_unit.\n"),i,j));
+	}
+
+    log_end(Special_Register_unit,FUNCTION);
+
+    return test;
+  };
+
+}; // end namespace special_register_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Parameters_print.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Parameters_print.cpp	(revision 88)
@@ -0,0 +1,56 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/include/Parameters.h"
+#include "Behavioural/include/XML.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace special_register_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Special_Register_unit::print"
+  std::string Parameters::print (uint32_t depth)
+  {
+    log_begin(Special_Register_unit,FUNCTION);
+
+    XML xml ("special_register_unit");
+
+    xml.balise_open("special_register_unit");
+//  xml.singleton_begin(""); xml.attribut("value",toString(_)); xml.singleton_end();
+    xml.balise_close();
+
+    log_end(Special_Register_unit,FUNCTION);
+    
+    return xml.get_body(depth);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Special_Register_unit::operator<<"
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::core::multi_ooo_engine::ooo_engine::special_register_unit::Parameters & x)
+  {
+    log_begin(Special_Register_unit,FUNCTION);
+
+    output_stream << x.print(0);
+    
+    log_end(Special_Register_unit,FUNCTION);
+
+    return output_stream;
+  };
+
+}; // end namespace special_register_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Special_Register_unit.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Special_Register_unit.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Special_Register_unit.cpp	(revision 88)
@@ -0,0 +1,167 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/include/Special_Register_unit.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace special_register_unit {
+
+
+#undef  FUNCTION
+#define FUNCTION "Special_Register_unit::Special_Register_unit"
+  Special_Register_unit::Special_Register_unit 
+  (
+#ifdef SYSTEMC
+   sc_module_name name,
+#else
+   string name,
+#endif
+#ifdef STATISTICS
+   morpheo::behavioural::Parameters_Statistics * param_statistics,
+#endif
+   morpheo::behavioural::core::multi_ooo_engine::ooo_engine::special_register_unit::Parameters * param,
+   morpheo::behavioural::Tusage_t usage
+   ):
+    _name              (name)
+    ,_param            (param)
+    ,_usage            (usage)
+  {
+    log_begin(Special_Register_unit,FUNCTION);
+
+    usage_environment(_usage);
+
+#if DEBUG_Core == true
+    log_printf(INFO,Core,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
+    log_printf(INFO,Special_Register_unit,FUNCTION,_("<%s> : Allocation"),_name.c_str());
+
+    allocation (
+#ifdef STATISTICS
+		param_statistics
+#endif
+		);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {	
+	log_printf(INFO,Special_Register_unit,FUNCTION,_("<%s> : Allocation of statistics"),_name.c_str());
+
+	statistics_allocation(param_statistics);
+      }
+#endif
+
+#ifdef VHDL
+    if (usage_is_set(_usage,USE_VHDL))
+      {
+	// generate the vhdl
+	log_printf(INFO,Special_Register_unit,FUNCTION,_("<%s> : Generate the vhdl"),_name.c_str());
+	
+	vhdl();
+      }
+#endif
+
+#ifdef SYSTEMC
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+	// Constant
+	for (uint32_t i=0; i<_param->_nb_inst_reexecute; i++)
+	  {
+	    internal_SPR_ACCESS_ACK [i] = 1;
+	    PORT_WRITE(out_SPR_ACCESS_ACK [i], internal_SPR_ACCESS_ACK [i]);
+	  }
+
+	for (uint32_t i=0; i<_param->_nb_front_end; i++)
+	  for (uint32_t j=0; j<_param->_nb_context[i]; j++)
+	    {
+	      internal_SPR_COMMIT_ACK [i][j] = 1;
+	      internal_SPR_EVENT_ACK  [i][j] = 1;
+	      PORT_WRITE(out_SPR_COMMIT_ACK [i][j], internal_SPR_COMMIT_ACK [i][j]);
+	      PORT_WRITE(out_SPR_EVENT_ACK  [i][j], internal_SPR_EVENT_ACK  [i][j]);
+	    }
+
+	log_printf(INFO,Special_Register_unit,FUNCTION,_("<%s> : Method - transition"),_name.c_str());
+
+	SC_METHOD (transition);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).pos();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+
+	log_printf(INFO,Special_Register_unit,FUNCTION,_("<%s> : Method - genMoore"),_name.c_str());
+
+	SC_METHOD (genMoore);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg(); // need internal register
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+
+	log_printf(INFO,Special_Register_unit,FUNCTION,_("<%s> : Method - genMealy_spr_access"),_name.c_str());
+
+	SC_METHOD (genMealy_spr_access);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg(); // need internal register
+	
+	for (uint32_t i=0; i<_param->_nb_inst_reexecute; i++)
+	  {
+	    sensitive << (*(in_SPR_ACCESS_NUM_GROUP    [i]))
+		      << (*(in_SPR_ACCESS_NUM_REG      [i]))
+// 		      << (*(in_SPR_ACCESS_VAL          [i]))
+// 		      << (*(in_SPR_ACCESS_WEN          [i]))
+	      ;
+	    if (_param->_have_port_front_end_id)
+	    sensitive << (*(in_SPR_ACCESS_FRONT_END_ID [i]));
+	    if (_param->_have_port_context_id)
+	    sensitive << (*(in_SPR_ACCESS_CONTEXT_ID   [i]));
+	  }
+
+
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+	
+#endif
+      }
+    log_end(Special_Register_unit,FUNCTION);
+  };
+    
+#undef  FUNCTION
+#define FUNCTION "Special_Register_unit::~Special_Register_unit"
+  Special_Register_unit::~Special_Register_unit (void)
+  {
+    log_begin(Special_Register_unit,FUNCTION);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {
+	statistics_deallocation();
+      }
+#endif
+
+    log_printf(INFO,Special_Register_unit,FUNCTION,_("<%s> : Deallocation"),_name.c_str());
+    deallocation ();
+
+    log_end(Special_Register_unit,FUNCTION);
+  };
+
+}; // end namespace special_register_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Special_Register_unit_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Special_Register_unit_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/src/Special_Register_unit_allocation.cpp	(revision 88)
@@ -0,0 +1,252 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Special_Register_unit/include/Special_Register_unit.h"
+#include "Behavioural/include/Allocation.h"
+#include "Common/include/Max.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace special_register_unit {
+
+
+
+#undef  FUNCTION
+#define FUNCTION "Special_Register_unit::allocation"
+  void Special_Register_unit::allocation (
+#ifdef STATISTICS
+			       morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+			       void
+#endif
+			       )
+  {
+    log_begin(Special_Register_unit,FUNCTION);
+
+    _component   = new Component (_usage);
+
+    Entity * entity = _component->set_entity (_name       
+					      ,"Special_Register_unit"
+#ifdef POSITION
+					      ,COMBINATORY 
+#endif
+					      );
+
+    _interfaces = entity->set_interfaces();
+
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      Interface * interface = _interfaces->set_interface(""
+#ifdef POSITION
+							 ,IN
+							 ,SOUTH,
+							 _("Generalist interface")
+#endif
+							 );
+      
+      in_CLOCK        = interface->set_signal_clk              ("clock" ,1, CLOCK_VHDL_YES);
+      in_NRESET       = interface->set_signal_in  <Tcontrol_t> ("nreset",1, RESET_VHDL_YES);
+    }
+
+    // ~~~~~[ Interface : "spr_access" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC1_INTERFACE("spr_access",IN,WEST, _("Access from reexecute_unit"), _param->_nb_inst_reexecute);
+
+      ALLOC1_VALACK_IN ( in_SPR_ACCESS_VAL           ,VAL);
+      ALLOC1_VALACK_OUT(out_SPR_ACCESS_ACK           ,ACK);
+      ALLOC1_SIGNAL_IN ( in_SPR_ACCESS_WEN           ,"wen"         ,Tcontrol_t         ,1);
+      ALLOC1_SIGNAL_IN ( in_SPR_ACCESS_CONTEXT_ID    ,"context_id"  ,Tcontext_t         ,_param->_size_context_id  );
+      ALLOC1_SIGNAL_IN ( in_SPR_ACCESS_FRONT_END_ID  ,"front_end_id",Tcontext_t         ,_param->_size_front_end_id);
+      ALLOC1_SIGNAL_IN ( in_SPR_ACCESS_NUM_GROUP     ,"num_group"   ,Tspr_address_t     ,_param->_size_special_address_group   );
+      ALLOC1_SIGNAL_IN ( in_SPR_ACCESS_NUM_REG       ,"num_reg"     ,Tspr_address_t     ,_param->_size_special_address_register);
+      ALLOC1_SIGNAL_IN ( in_SPR_ACCESS_WDATA         ,"wdata"       ,Tspr_t             ,_param->_size_spr);
+      ALLOC1_SIGNAL_OUT(out_SPR_ACCESS_RDATA         ,"rdata"       ,Tspr_t             ,_param->_size_spr);
+      ALLOC1_SIGNAL_OUT(out_SPR_ACCESS_INVALID       ,"invalid"     ,Tcontrol_t         ,1);
+    }
+
+    // ~~~~~[ Interface : "spr_read" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC2_INTERFACE("spr_read",OUT,WEST, _("Output for a spr bit field."), _param->_nb_front_end, _param->_nb_context[it1]);
+
+      _ALLOC2_SIGNAL_OUT(out_SPR_READ_SR             ,"sr",Tspr_t,_param->_size_spr, _param->_nb_front_end, _param->_nb_context[it1]);
+    }
+
+    // ~~~~~[ Interface : "spr_commit" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC2_INTERFACE("spr_commit",IN,WEST, _("Commit instruction to change SR's flags."), _param->_nb_front_end, _param->_nb_context[it1]);
+
+      _ALLOC2_VALACK_IN ( in_SPR_COMMIT_VAL           ,VAL,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_VALACK_OUT(out_SPR_COMMIT_ACK           ,ACK,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_SPR_COMMIT_SR_F_VAL      ,"sr_f_val"     ,Tcontrol_t         ,1,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_SPR_COMMIT_SR_F          ,"sr_f"         ,Tcontrol_t         ,1,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_SPR_COMMIT_SR_CY_VAL     ,"sr_cy_val"    ,Tcontrol_t         ,1,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_SPR_COMMIT_SR_CY         ,"sr_cy"        ,Tcontrol_t         ,1,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_SPR_COMMIT_SR_OV_VAL     ,"sr_ov_val"    ,Tcontrol_t         ,1,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_SPR_COMMIT_SR_OV         ,"sr_ov"        ,Tcontrol_t         ,1,_param->_nb_front_end, _param->_nb_context[it1]);
+    }
+
+    // ~~~~~[ Interface "spr_event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC2_INTERFACE("spr_event",IN,WEST, _("Event change a lot of exception."), _param->_nb_front_end, _param->_nb_context[it1]);
+
+      _ALLOC2_VALACK_IN ( in_SPR_EVENT_VAL            ,VAL,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_VALACK_OUT(out_SPR_EVENT_ACK            ,ACK,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_SPR_EVENT_EPCR          ,"EPCR"          ,Tspr_t            ,_param->_size_spr,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_SPR_EVENT_EEAR_WEN      ,"EEAR_WEN"      ,Tcontrol_t        ,1                ,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_SPR_EVENT_EEAR          ,"EEAR"          ,Tspr_t            ,_param->_size_spr,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_SPR_EVENT_SR_DSX        ,"SR_DSX"        ,Tcontrol_t        ,1                ,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_SPR_EVENT_SR_TO_ESR     ,"SR_TO_ESR"     ,Tcontrol_t        ,1                ,_param->_nb_front_end, _param->_nb_context[it1]);
+    }
+
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    internal_SPR_ACCESS_ACK = new Tcontrol_t   [_param->_nb_inst_reexecute];
+    internal_SPR_COMMIT_ACK = new Tcontrol_t * [_param->_nb_front_end];
+    internal_SPR_EVENT_ACK  = new Tcontrol_t * [_param->_nb_front_end];
+    for (uint32_t i=0; i<_param->_nb_front_end; i++)
+      {
+        internal_SPR_COMMIT_ACK [i]  = new Tcontrol_t [_param->_nb_context [i]];
+        internal_SPR_EVENT_ACK  [i]  = new Tcontrol_t [_param->_nb_context [i]];
+      }
+      }
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+    _spr_access_mode = new SPR_access_mode ** [_param->_nb_front_end];
+    for (uint32_t i=0; i<_param->_nb_front_end; i++)
+      {
+	_spr_access_mode [i] = new SPR_access_mode * [_param->_nb_context[i]];
+
+	for (uint32_t j=0; j<_param->_nb_context[i]; j++)
+	  {
+	    _spr_access_mode [i][j] = new SPR_access_mode;
+
+	    for (uint32_t k=0; k<NB_GROUP; k++)
+	      if (_param->_implement_group [i][j][k])
+		_spr_access_mode [i][j]->implement_group(k);
+	  }
+      }
+
+    _spr = new SPR **** [_param->_nb_front_end];
+    for (uint32_t i=0; i<_param->_nb_front_end; i++)
+      {
+	_spr [i] = new SPR *** [_param->_nb_context[i]];
+
+	for (uint32_t j=0; j<_param->_nb_context[i]; j++)
+	  {
+	    _spr [i][j] = new SPR ** [NB_GROUP];
+
+	    for (uint32_t k=0; k<NB_GROUP; k++)
+	      if (_param->_implement_group [i][j][k])
+		{
+		  _spr [i][j][k] = new SPR * [NB_REG_GROUP[k]];
+
+		  switch (k)
+		    {
+		    case GROUP_SYSTEM_AND_CONTROL  :
+		      {
+			_spr [i][j][k][SPR_VR          ] = new VR          (i,j,_param);
+			_spr [i][j][k][SPR_UPR         ] = new UPR         (i,j,_param);
+			_spr [i][j][k][SPR_CPUCFGR     ] = new CPUCFGR     (i,j,_param);
+			_spr [i][j][k][SPR_DMMUCFGR    ] = new DMMUCFGR    (i,j,_param);
+			_spr [i][j][k][SPR_IMMUCFGR    ] = new IMMUCFGR    (i,j,_param);
+			_spr [i][j][k][SPR_DCCFGR      ] = new DCCFGR      (i,j,_param);
+			_spr [i][j][k][SPR_ICCFGR      ] = new ICCFGR      (i,j,_param);
+			_spr [i][j][k][SPR_DCFGR       ] = new DCFGR       (i,j,_param);
+			_spr [i][j][k][SPR_PCCFGR      ] = new PCCFGR      (i,j,_param);
+			_spr [i][j][k][SPR_NPC         ] = new NPC         (i,j,_param);
+			_spr [i][j][k][SPR_SR          ] = new SR          (i,j,_param);
+			_spr [i][j][k][SPR_PPC         ] = new PPC         (i,j,_param);
+			_spr [i][j][k][SPR_CID         ] = new CID         (i,j,_param);
+			_spr [i][j][k][SPR_FPCSR       ] = new FPCSR       (i,j,_param);
+			_spr [i][j][k][SPR_EPCR        ] = new EPCR        (i,j,_param);
+			_spr [i][j][k][SPR_EEAR        ] = new EEAR        (i,j,_param);
+			_spr [i][j][k][SPR_ESR         ] = new ESR         (i,j,_param);
+// 			_spr [i][j][k][SPR_GPR         ] = new GPR         (i,j,_param);
+			
+			break;
+		      }
+		    case GROUP_DCACHE              :
+		      {
+			_spr [i][j][k][SPR_DCCR        ] = new DCCR        (i,j,_param);
+			_spr [i][j][k][SPR_DCBPR       ] = new DCBPR       (i,j,_param);
+			_spr [i][j][k][SPR_DCBFR       ] = new DCBFR       (i,j,_param);
+			_spr [i][j][k][SPR_DCBIR       ] = new DCBIR       (i,j,_param);
+			_spr [i][j][k][SPR_DCBWR       ] = new DCBWR       (i,j,_param);
+			_spr [i][j][k][SPR_DCBLR       ] = new DCBLR       (i,j,_param);
+
+			break;
+		      }
+		    case GROUP_DMMU                :
+		    case GROUP_IMMU                :
+		    case GROUP_ICACHE              :
+		    case GROUP_DEBUG               :
+		    case GROUP_PERFORMANCE_COUNTER :
+		    case GROUP_POWER_MANAGEMENT    :
+		    case GROUP_PIC                 :
+		    case GROUP_TICK_TIMER          :
+		    case GROUP_FLOATING_POINT      :
+
+		    case GROUP_MAC                 :
+		    case GROUP_RESERVED_1          :
+		    case GROUP_RESERVED_2          :
+		    case GROUP_RESERVED_3          :
+		    case GROUP_RESERVED_4          :
+		    case GROUP_RESERVED_5          :
+		    case GROUP_RESERVED_6          :
+		    case GROUP_RESERVED_7          :
+		    case GROUP_RESERVED_8          :
+		    case GROUP_RESERVED_9          :
+		    case GROUP_RESERVED_10         :
+		    case GROUP_RESERVED_11         :
+		    case GROUP_RESERVED_12         :
+		    case GROUP_CUSTOM_1            :
+		    case GROUP_CUSTOM_2            :
+		    case GROUP_CUSTOM_3            :
+		    case GROUP_CUSTOM_4            :
+		    case GROUP_CUSTOM_5            :
+		    case GROUP_CUSTOM_6            :
+		    case GROUP_CUSTOM_7            :
+		    case GROUP_CUSTOM_8            :
+		    default :
+		      {
+			for (uint32_t l=0; l<NB_REG_GROUP[k]; l++)
+			  _spr [i][j][k][l] = NULL;
+		      }
+		    }
+		}
+	      else
+		_spr [i][j][k] = NULL;
+	  }
+      }
+    
+    for (uint32_t i=0; i<_param->_nb_front_end; i++)
+      for (uint32_t j=0; j<_param->_nb_context[i]; j++)
+	for (uint32_t k=0; k<NB_GROUP; k++)
+	  if (_param->_implement_group [i][j][k])
+	    for (uint32_t l=0; l<NB_REG_GROUP[k]; l++)
+	      if (_spr [i][j][k][l] == NULL)
+		_spr_access_mode [i][j]->invalid_register (k,l);
+
+#ifdef POSITION
+    if (usage_is_set(_usage,USE_POSITION))
+      _component->generate_file();
+#endif
+
+    log_end(Special_Register_unit,FUNCTION);
+  };
+
+}; // end namespace special_register_unit
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
